=begin
(c) TIG 2011
Type
  Exportcpoints2csv.new
in the Ruby Console.
Exports all Cpoints is a Selection to a X,Y,Z 'CSV' file.
Edit sep="," if something other than a separating comma is desired e.g. ';'
Make sep="\t" if a TSV file is desired and change ext="csv" to ext="tsv".
It uses the current Model Units/accuracy with the approximate '~ ' and 
unit suffix [if any] removed; e.g. change Model Units to 'meters' 3dp to 
get exported csv in meters 1.234 - don't use 'fraction' 1' 2 1/2" formats, 
always use a 'decimal' format.
1.0 20110913 First issue.
=end
require 'sketchup.rb'
###
class Exportcpoints2csv
def initialize()
    sep="," ### <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
    ext="csv" ### <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
    model=Sketchup.active_model
    ss=model.selection
    cpoints=[]
    ss.each{|e|cpoints << e if e.class==Sketchup::ConstructionPoint}
    if not cpoints
      UI.messagebox("No Cpoints were Selected.\nExiting.")
	  return nil
    end#if
    pts=[]
    cpoints.each{|p|pts << p.position.x.to_s.gsub(/^~ /,'').to_f.to_s+sep+p.position.y.to_s.gsub(/^~ /,'').to_f.to_s+sep+p.position.z.to_s.gsub(/^~ /,'').to_f.to_s}
    path=model.path
    if not path or path==""
      path=Dir.pwd
      title="Untitled"
    else
      path=File.dirname(path)
      title=model.title
    end#if
    ofile=File.join(path,title+'_cpoints.'+ext).tr("\\","/")
    begin
      file=File.new(ofile,"w")
    rescue### trap if open
      UI.messagebox("Cpoints File:\n\n  "+ofile+"\n\nCannot be written - it's probably already open.\nClose it and try making it again...\n\nExiting...")
	  return nil
    end
    pts.each{|pt|file.puts(pt)}
    file.close
    puts (pts.length.to_s)+" cpoints written to\n"+ofile
    puts pts
    puts 'DONE.'
    begin
      UI.openURL("file:/"+ofile)
    rescue
    end
end#def
end#class
###


